/*******************************************************************************
 * Copyright (c) 2009 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.e4.languages.javascript.jsdi.rhino;

import org.eclipse.e4.languages.javascript.jsdi.Property;

/**
 * Rhino implementation of {@link Property}
 * 
 * @since 1.0
 */
public class PropertyImpl extends MirrorImpl implements Property {

	private String name;
	private Number ref;

	/**
	 * Constructor
	 * 
	 * @param vm
	 * @param name
	 * @param ref
	 */
	public PropertyImpl(VirtualMachineImpl vm, String name, Number ref) {
		super(vm);
		this.name = name;
		this.ref = ref;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.e4.languages.javascript.jsdi.Property#name()
	 */
	public String name() {
		return name;
	}

	/**
	 * @return
	 */
	public Number getRef() {
		return ref;
	}
}
